from __future__ import print_function
from __future__ import division
from preprocessing import preprocess_data
import joblib
import pandas as pd
import numpy as np
print("processing test data...")
sj_test, iq_test = preprocess_data('./data/dengue_features_test.csv')
print("getting pickled model...")
file = open('./data/sj_model.pkl', 'rb')
sj_model = joblib.load(file)
file = open('./data/iq_model.pkl', 'rb')
iq_model = joblib.load(file)
print("Predicting values...")    
sj_predictions = sj_model.predict(sj_test).astype(int)
iq_predictions = iq_model.predict(iq_test).astype(int)
submission = pd.read_csv("./data/submission_format.csv",
                         index_col=[0, 1, 2])
submission.total_cases = np.concatenate([sj_predictions, iq_predictions])
print("saving output file")
submission.to_csv("./data/output_file.csv")