# -*- coding: utf-8 -*-
"""
Created on Thu Oct 31 11:19:23 2019

@author: Marvin
"""
from __future__ import print_function
from __future__ import division
import joblib
from best_model import get_best_model
import pandas as pd

# Imports for saving of params and metrics
import json

sj_train = pd.read_csv("./data/featurized_train_sj.csv")
iq_train = pd.read_csv("./data/featurized_train_iq.csv")
sj_train_subtrain = sj_train.head(800)
sj_train_subtest = sj_train.tail(sj_train.shape[0] - 800)
iq_train_subtrain = iq_train.head(400)
iq_train_subtest = iq_train.tail(iq_train.shape[0] - 400)
print("Finding the best model...")
[sj_best_model, sj_best_alpha, sj_best_score] = get_best_model(sj_train_subtrain, sj_train_subtest)
[iq_best_model, iq_best_alpha, iq_best_score] = get_best_model(iq_train_subtrain, iq_train_subtest)
print("saving metrics and params...")
params = {
    'sj_best_alpha': sj_best_alpha,
    'iq_best_alpha': iq_best_alpha,
}
with open('./code/params.json', 'w') as f:
    json.dump(params, f)
with open('./metrics/sj_best_score.json', 'w') as f:
    json.dump({'sj_best_score': sj_best_score}, f)
with open('./metrics/iq_best_score.json', 'w') as f:
    json.dump({'iq_best_score': iq_best_score}, f)
print("saving model as joblib...")
with open("./data/sj_model.pkl", 'wb') as f:
    joblib.dump(sj_best_model, f)
with open("./data/iq_model.pkl", 'wb') as f:
    joblib.dump(iq_best_model, f)